//////////////////////////////////////////////////////////////////////////////////////////
//	ARB_texture_env_combine_extension.cpp
//	ARB_texture_env_combine extension setup
//	You may use this code however you wish, but if you do, please credit me and
//	provide a link to my website in a readme file or similar
//	Downloaded from: www.paulsprojects.net
//	Created:	15th November 2002
//////////////////////////////////////////////////////////////////////////////////////////	
#include <windows.h>
#include <stdio.h>
#include <gl\glut.h>
#include "..\glext.h"
#include "..\wglext.h"
#include "ARB_texture_env_combine_extension.h"

bool ARB_texture_env_combine_supported=false;

bool SetUpARB_texture_env_combine()
{
	//Check for support
	char * extensionString=(char *)glGetString(GL_EXTENSIONS);
	char * extensionName="GL_ARB_texture_env_combine";

	char * endOfString;									//store pointer to end of string
	unsigned int distanceToSpace;						//distance to next space

	endOfString=extensionString+strlen(extensionString);

	//loop through string
	while(extensionString<endOfString)
	{
		//find distance to next space
		distanceToSpace=strcspn(extensionString, " ");

		//see if we have found extensionName
		if((strlen(extensionName)==distanceToSpace) &&
			(strncmp(extensionName, extensionString, distanceToSpace)==0))
		{
			ARB_texture_env_combine_supported=true;
		}

		//if not, move on
		extensionString+=distanceToSpace+1;
	}

	if(!ARB_texture_env_combine_supported)
	{
		printf("ARB_texture_env_combine unsupported!\n");
		return false;
	}

	printf("ARB_texture_env_combine supported!\n");

	//get function pointers
	//None specified

	return true;
}